// A sample program that loads a WAV file into an audio buffer and plays it.

#include <EvoWaveAudioFile.h>
#include <EvoAudioBuffer.h>
#include <EvoAudioManager.h>
#include <iostream.h>

int main ()
{
	EvoWaveAudioFile file("test.wav");
	if (!file.open('r')) {
		cout << "Failed opening file";
		return 0;
	}

	EvoAudioBuffer *audioBuffer = file.read();
	audioBuffer->setSampleFormat(paFloat32);

	EvoError e;
	EvoAudioManager manager(audioBuffer->getNumChannels(),  // number of channels
                            audioBuffer->getSampleRate(),   // sampling rate
                            1024,                           // frames per buffer
                            e);
	
	if (e != EVO_NOERROR) {
		cout << "Failed to initialize audio manager";
		return 0;
	}

    for (int i = 0; i < audioBuffer->getNumChannels(); i++)
	    manager.getActiveOutputDevice()->connect(audioBuffer, i, i);

	e = manager.getActiveOutputDevice()->start();
	if (e != EVO_NOERROR) {
		cout << "Failed to start output device";
		return 0;
	}

	audioBuffer->play(false, false);
	Pa_Sleep(audioBuffer->getLengthMs());
	return 0;
}